import React from 'react';
import { makeClasses } from './helpers/object';
import Form from 'react-bootstrap/Form';
export function PaginationOptsGroup({ classes, labels, value, onChange, options }) {
    return (React.createElement(Form, { className: makeClasses('paginationOpts__root', classes.paginationOptsForm) },
        React.createElement(Form.Group, { controlId: "formGroupPagination", className: classes.paginationOptsFormGroup },
            React.createElement("span", { className: classes.paginationOptsFormText },
                labels.show || 'Show',
                ' '),
            React.createElement(Form.Control, { name: "form-control-pagination", defaultValue: value, as: "select", placeholder: "select", onChange: onChange, className: classes.paginationOptsFormControl }, options.map((option, idx) => {
                const optionProps = {
                    key: `page-opt-${option}`,
                    value: option
                };
                return React.createElement("option", { ...optionProps }, option);
            })),
            React.createElement("span", { className: classes.paginationOptsFormText },
                ' ',
                labels.entries || 'entries'))));
}
export default function PaginationOpts({ labels, rowsPerPage, rowsPerPageOption, onRowsPerPageChange, classes, CustomPaginationOptsGroup }) {
    function onRowsPerPageChangeHandler(e) {
        onRowsPerPageChange(Number(e.target.value));
    }
    let renderedElements = null;
    if (rowsPerPage !== undefined) {
        let opts = [rowsPerPage];
        // Make sure there are no duplicates being pushed.
        if (rowsPerPageOption !== undefined) {
            rowsPerPageOption.forEach((opt) => {
                if (!opts.includes(opt) && typeof opt === 'number') {
                    opts.push(opt);
                }
            });
            // Order the pagination options ascending.
            opts = opts.sort((a, b) => {
                if (a < b) {
                    return -1;
                }
                else if (a > b) {
                    return 1;
                }
                return 0;
            });
        }
        // Only render option if the length is more than 1.
        if (opts.length > 1) {
            const UsedPaginationOpts = CustomPaginationOptsGroup || PaginationOptsGroup;
            renderedElements = (React.createElement(UsedPaginationOpts, { classes: classes, labels: labels, onChange: onRowsPerPageChangeHandler, options: opts, value: rowsPerPage }));
        }
    }
    return renderedElements;
}
